SystemOrganization addCategory: #'GT-Inspector'!
SystemOrganization addCategory: 'GT-Inspector-Example-Tools'!
SystemOrganization addCategory: 'GT-Inspector-Examples-Core'!
SystemOrganization addCategory: 'GT-Inspector-Examples-Exceptions'!
SystemOrganization addCategory: 'GT-Inspector-Examples-UI'!
SystemOrganization addCategory: 'GT-Inspector-Examples-Utils'!

!RPackageTag methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 16:34'!
gtExamplesContained
	^ self classes gather: [ :each | each gtExamples ]! !

!SystemNavigation methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/7/2015 23:12'!
examplesReferencesTo: aLiteral
	^ GTExampleFinder gtExamples select: [ :each | 
			(each hasSubject: aLiteral)
				or: [ (each method hasLiteralThorough: aLiteral)
					or: [ (each source theNonMetaClass name asString = aLiteral name asString) ] ] ]! !

!TClassDescription methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:43'!
gtExamples
	^ self gtExamplesFinder gtExamples! !

!TClassDescription methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 17:48'!
gtExamplesFinder
	^ GTExampleFinder new
		source: self gtExamplesSource;
		provider: self gtExamplesProvider;
		subjects: self gtExamplesSubjects;
		yourself! !

!TClassDescription methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:46'!
gtExamplesProvider
	" by default let a class be the provider for examples "
	^ self! !

!TClassDescription methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:46'!
gtExamplesSource
	" by default let a class be the source for examples "
	^ self! !

!TClassDescription methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:46'!
gtExamplesSubjects
	" by default let a class be the (implicit) subject for examples "
	^ nil! !

!CompiledMethod methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:38'!
gtExamples
	| examples |
	examples := OrderedCollection new.
	self methodClass theNonMetaClass gtExamplesFinder method: self to: examples.
	^ examples! !

!HelpTopic methodsFor: '*GT-Inspector' stamp: 'AndreiChis 3/6/2015 10:35'!
gtDisplayOn: stream
	^ stream nextPutAll: self title! !

AbstractMethodIconAction subclass: #GTExampleNautilusAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-UI'!

!GTExampleNautilusAction methodsFor: 'order' stamp: 'StefanReichhart 9/4/2015 17:51'!
actionOrder
	"Return the priority of this action"
	
	^ 0! !

!GTExampleNautilusAction methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:49'!
iconForMethod: aCompiledMethod
	| result |
	(result := self resultForMethod: aCompiledMethod)
		ifNil: [ ^ Smalltalk ui icons iconNamed: #testNotRunIcon ].
	result isSuccess
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testGreenIcon ].
	result isFailure
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testYellowIcon ].
	result isError
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testRedIcon ].
	^ Smalltalk ui icons iconNamed: #testNotRunIcon! !

!GTExampleNautilusAction methodsFor: 'order' stamp: 'StefanReichhart 9/6/2015 16:58'!
isActionHandled
	^ method pragmas anySatisfy: [ :each | each isGTExamplePragma ]! !

!GTExampleNautilusAction methodsFor: 'order' stamp: 'StefanReichhart 9/4/2015 17:56'!
privateActionIcon
	"Return the icon for this action"
	^ IconicButton new
		target: self;
		actionSelector: #run:;
		arguments: { method };
		labelGraphic: (self iconForMethod: method);
		color: Color transparent;
		helpText: 'Run';
		extent: 12 @ 12;
		borderWidth: 0! !

!GTExampleNautilusAction methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 16:36'!
resultForMethod: aCompiledMethod
	^ aCompiledMethod gtExamples 
		ifNotEmpty: [ :examples | examples first result ]
		ifEmpty: [ nil ]! !

!GTExampleNautilusAction methodsFor: 'order' stamp: 'StefanReichhart 9/4/2015 18:02'!
run: aCompiledMethod
	(self resultForMethod: aCompiledMethod)
		ifNotNil: [ :result | result debug ]! !

!AbstractNautilusUI class methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 17:46'!
examplesClassMenu: aBuilder
	<contextMenu>
	<nautilusGlobalClassMenu>
	^ GTExampleNautilus new
		onClass: aBuilder;
		yourself! !

!AbstractNautilusUI class methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 17:46'!
examplesMethodMenu: aBuilder
	<contextMenu>
	<nautilusGlobalMethodMenu>
	^ GTExampleNautilus new
		onCompiledMethod: aBuilder;
		yourself! !

!AbstractNautilusUI class methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 17:46'!
examplesPackageMenu: aBuilder
	<contextMenu>
	<nautilusGlobalPackageMenu>
	^ GTExampleNautilus new
		onPackage: aBuilder;
		yourself! !

!TClass methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 16:33'!
gtInspectorGTExamplesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Examples';
		display: [ self gtExamples ];
		icon: #icon;
		format: #gtDisplayString;
		when: [ self gtExamples notEmpty ]! !

!TClass methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 16:46'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ self gtExamples ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!Error methodsFor: '*GT-Inspector-Examples-Exceptions' stamp: 'StefanReichhart 6/28/2015 17:09'!
isExamplesFailure
	^ true! !

Error subclass: #GTExampleError
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

GTExampleError subclass: #GTExampleArgumentError
	instanceVariableNames: 'expected defined evaluated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleArgumentError methodsFor: 'accessing' stamp: 'StefanReichhart 7/24/2015 18:29'!
defined
	^ defined! !

!GTExampleArgumentError methodsFor: 'accessing' stamp: 'StefanReichhart 7/24/2015 18:29'!
defined: anObject
	defined := anObject! !

!GTExampleArgumentError methodsFor: 'accessing' stamp: 'StefanReichhart 7/24/2015 18:28'!
evaluated
	^ evaluated! !

!GTExampleArgumentError methodsFor: 'accessing' stamp: 'StefanReichhart 7/24/2015 18:28'!
evaluated: anObject
	evaluated := anObject! !

!GTExampleArgumentError methodsFor: 'accessing' stamp: 'StefanReichhart 7/24/2015 18:17'!
expected
	^ expected! !

!GTExampleArgumentError methodsFor: 'accessing' stamp: 'StefanReichhart 7/24/2015 18:17'!
expected: anObject
	expected := anObject! !

GTExampleError subclass: #GTExampleDeclaredClassMissing
	instanceVariableNames: 'classNamed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleDeclaredClassMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:54'!
classNamed
	^ classNamed! !

!GTExampleDeclaredClassMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:54'!
classNamed: anObject
	classNamed := anObject! !

GTExampleError subclass: #GTExampleDeclaredMethodMissing
	instanceVariableNames: 'methodClass selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleDeclaredMethodMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:52'!
methodClass
	^ methodClass! !

!GTExampleDeclaredMethodMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:52'!
methodClass: anObject
	methodClass := anObject! !

!GTExampleDeclaredMethodMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:51'!
selector
	^ selector! !

!GTExampleDeclaredMethodMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:51'!
selector: anObject
	selector := anObject! !

GTExampleError subclass: #GTExampleDependencyError
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 9/2/2015 22:02'!
exception
	^ exception! !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 9/2/2015 22:02'!
exception: anObject
	exception := anObject! !

!GTExampleDependencyError methodsFor: 'testing' stamp: 'StefanReichhart 9/4/2015 15:40'!
isExampleError
	^ self exception 
		ifNotNil: [ self exception isExampleError ]
		ifNil: [ super isExampleError ]! !

!GTExampleError methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:01'!
example
	^ example! !

!GTExampleError methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:01'!
example: anObject
	example := anObject! !

!GTExampleError methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2015 12:03'!
isExampleError
	^ true! !

GTExampleError subclass: #GTExampleRecursionDetected
	instanceVariableNames: 'resolved next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
next
	^ next! !

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
next: anObject
	next := anObject! !

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
resolved
	^ resolved! !

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
resolved: anObject
	resolved := anObject! !

Error subclass: #GTExampleExpectedExceptionNotRaised
	instanceVariableNames: 'expectedError exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:46'!
exception
	^ exception! !

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:46'!
exception: anObject
	exception := anObject! !

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:48'!
expectedError
	^ expectedError! !

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:48'!
expectedError: anObject
	expectedError := anObject! !

Error subclass: #GTExampleUnexpectedExceptionRaised
	instanceVariableNames: 'unexpectedError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Exceptions'!

!GTExampleUnexpectedExceptionRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:49'!
unexpectedError
	^ unexpectedError! !

!GTExampleUnexpectedExceptionRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:49'!
unexpectedError: anObject
	unexpectedError := anObject! !

!Collection methodsFor: '*GT-Inspector' stamp: 'TudorGirba 6/28/2014 22:19'!
gtInspectorInterestingObject
	^ self size = 1
		ifTrue: [ self anyOne ]
		ifFalse: [ self ]! !

!RPackage methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 16:34'!
gtExamplesContained
	^ self classes gather: [ :each | each gtExamples ]! !

GLMCompositePresentation subclass: #GTInspector
	instanceVariableNames: 'presentationFilter'
	classVariableNames: 'GTInspectorEnabledStatus GTNumberOfInspectorPanes PreferredExtent RememberPreferredExtent'
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspector commentStamp: 'TudorGirba 8/21/2011 16:57' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One particular feature is that you can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

The object finder asks dynamically the object for the actual presentations that are displayed in each pane.

Example:
self openOn: Smalltalk.

Register it as a replacement for explorer:
self registerToolsOn: Smalltalk tools.!

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/1/2013 22:16'!
explore: anObject 
	self openOn: anObject.
	^ anObject! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:38'!
extentSettingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #GTInspectorPreferredWidth)
		target: self;
		parent: #gt;
		getSelector: #preferredWidth;
		setSelector: #preferredWidth:; 
		label: 'Inspector width';
		description: 'The preferred width of new Inspector windows'.
	(aBuilder setting: #GTInspectorPreferredHeight)
		target: self;
		parent: #gt;
		getSelector: #preferredHeight;
		setSelector: #preferredHeight:; 
		label: 'Inspector height';
		description: 'The preferred height of new Inspector windows'.
	(aBuilder setting: #GTInspectorRememberPreferredExtent)
		target: self;
		parent: #gt;
		getSelector: #rememberPreferredExtent;
		setSelector: #rememberPreferredExtent:; 
		label: 'Remember extent of Inspector';
		description: 'Enable or disable remembering of the extent of Inspector windows on resize. When the preference is true, resizing a Inspector window will affect the preferred width and height of future Inspector windows'
! !

!GTInspector class methodsFor: 'inspecting' stamp: 'TudorGirba 3/8/2014 07:51'!
gtInspectorExtensionsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Extensions';
		display: [ self inspectorExtendingMethods ];
		showOnly: 50;
		format: [ :each | each gtDisplayString ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!GTInspector class methodsFor: 'class initialization' stamp: 'TudorGirba 10/7/2012 22:50'!
initialize 
	self numberOfInspectorPanes: 2! !

GTInspector initialize!

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/1/2013 22:16'!
inspect: anObject 
	self openOn: anObject.
	^ anObject! !

!GTInspector class methodsFor: 'openning' stamp: 'AndreiChis 4/16/2014 18:15'!
inspect: anObject label: aString
	self new 
		title: aString;
		openOn: anObject.
	^ anObject
! !

!GTInspector class methodsFor: 'openning' stamp: 'AndreiChis 10/28/2014 13:53'!
inspector: anObject

	^ self openOn: anObject! !

!GTInspector class methodsFor: 'inspecting' stamp: 'TudorGirba 2/7/2014 08:31'!
inspectorExtendingMethods
	^ (Object withAllSubclasses
		flatCollect: [ :each | 
			(Pragma allNamed: #gtInspectorPresentationOrder: in: each) 
				collect: [ :p | p method asRingDefinition ] ])
		sorted! !

!GTInspector class methodsFor: 'settings' stamp: 'AndreiChis 8/29/2014 00:48'!
isGTInspectorEnabled

	^ GTInspectorEnabledStatus ifNil: [ GTInspectorEnabledStatus := Smalltalk tools inspector = self ]! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/7/2012 22:46'!
numberOfInspectorPanes
	^ GTNumberOfInspectorPanes ! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/7/2012 22:46'!
numberOfInspectorPanes: anInteger
	GTNumberOfInspectorPanes := anInteger ! !

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/25/2012 22:53'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:36'!
preferredExtent
	^ PreferredExtent ifNil: [ PreferredExtent := 600@400 ]! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
preferredExtent: aPoint
	PreferredExtent := aPoint! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
preferredHeight
	^ self preferredExtent y! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
preferredHeight: aHeight
	self preferredExtent setX: self preferredExtent x setY: aHeight! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
preferredWidth
	^ self preferredExtent x! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
preferredWidth: aWidth
	self preferredExtent setX: aWidth setY: self preferredExtent y! !

!GTInspector class methodsFor: 'tools registry' stamp: 'AndreiChis 8/28/2014 21:21'!
register

	self registerToolsOn: Smalltalk tools
! !

!GTInspector class methodsFor: 'tools registry' stamp: 'TudorGirba 11/1/2013 22:17'!
registerToolsOn: registry
	"self registerToolsOn: Smalltalk tools " 
	registry register: self as: #inspector
! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
rememberPreferredExtent
	^ RememberPreferredExtent ifNil: [ RememberPreferredExtent := true ]! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:37'!
rememberPreferredExtent: aBoolean
	^ RememberPreferredExtent := aBoolean! !

!GTInspector class methodsFor: 'settings' stamp: 'AndreiChis 8/28/2014 21:27'!
setGTInspectorEnabledStatus: aBoolean
	| oldStatus |
	
	oldStatus := self isGTInspectorEnabled.
	GTInspectorEnabledStatus := aBoolean.
	oldStatus ~= GTInspectorEnabledStatus ifTrue: [ 
		GTInspectorEnabledStatus 
			ifTrue: [ self register ]
			ifFalse: [ EyeInspector registerToolsOn: Smalltalk tools ] ]
	
	! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 3/26/2015 00:40'!
setPreferredExtentIfWanted: anExtent
	self rememberPreferredExtent ifTrue: [ 
		self preferredExtent: anExtent ]! !

!GTInspector class methodsFor: 'settings' stamp: 'AndreiChis 8/28/2014 21:46'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder group: #gt)
		label: 'Glamorous Toolkit';
		with: [
			(aBuilder setting: #numberOfInspectorPanes)
				target: self; 
				label: 'Number of inspector panes';
		 		description: 'Specifies the maximum number of panes that are visible at every moment in a Glamorous Inspector.'.
			(aBuilder setting: #GTInspectorStatus)
				target: self;
				getSelector: #isGTInspectorEnabled;
				setSelector: #setGTInspectorEnabledStatus:; 
				label: 'GTInspector';
		 		description: 'Enable or disable the GTInspector.'.]! !

!GTInspector methodsFor: 'callbacks' stamp: 'AndreiChis 10/5/2014 21:27'!
actOnPaneAdded: ann

	self panes size > 1 ifTrue: [ 
		(self panes before: self panes last) updateToolbar "announce: (GLMPresentationToolbarUpdated new presentation: ann presentation)" ]! !

!GTInspector methodsFor: 'actions' stamp: 'EstebanLorenzano 12/7/2014 09:47'!
closeActionFor: aPresentation

	^ GLMGenericAction new
			action: [ self removeLastPane ];
			icon: GLMUIThemeExtraIcons glamorousClose;
			condition: [ :currentPresentation |
				self panes size > 1 and: [ self panes last presentations = currentPresentation ] ];
			title: 'Close' ! !

!GTInspector methodsFor: 'building' stamp: 'AndreiChis 1/18/2015 21:34'!
compose
	self title: [:anObject | 'Inspector on ', (self printObjectAsAnItem: anObject)].
	self act: [:b | b update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Update'.
	self act: [:b | b presentationFilter ifNotNil: [ :filter | filter changeFilterRequestFor: b] ] entitled: 'Filter presentations'.
	self pager with: [ :browser | 
		browser fixedSizePanes: self class numberOfInspectorPanes.
		browser show: [ :a :each |
			a title: [ self printObjectAsAnItem: each ].
			a dynamicActions: [ :aPresentation | 
				each gtInspectorActions asOrderedCollection ].
			a titleAction: [ :aPresentation | self closeActionFor: aPresentation ].
			a dynamic 
				display: [ :x | 
					(GLMCompositePresentation new with: [:d | 
						each 
							gtInspectorPresentationsIn: d 
							inContext: self ])
							startOn: x ] ] ].
			
	self first when: GLMPaneAdded send: #actOnPaneAdded: to: self! !

!GTInspector methodsFor: 'accessing' stamp: 'TudorGirba 3/13/2014 13:39'!
entities
	"returns the list of objects from the #entity port of each pane of the finder"
	^ self first panes collect: [ :each | 
		(each port: #entity) value ]! !

!GTInspector methodsFor: 'context' stamp: 'AndreiChis 1/27/2015 23:35'!
filterByMethods: aCollection
	| filter |
	
	filter := GTInspectorMethodListFilter new.
	aCollection  do: [ :aMethod |
		filter addAndSelectSignatureFor: aMethod ].
	self presentationFilter: filter
		! !

!GTInspector methodsFor: 'accessing' stamp: 'AndreiChis 1/30/2015 11:35'!
firstPresentation

	^ self panes first presentations first! !

!GTInspector methodsFor: 'initialization' stamp: 'AndreiChis 1/27/2015 23:30'!
initialize
	super initialize.
	
	self presentationFilter: (GTInspectorTagFilter new
			defaultTag: #custom;
			addAndSelectTag: #basic;
			addAndSelectTag: #custom;
			addAndSelectTag: #examples)! !

!GTInspector methodsFor: 'actions' stamp: 'TudorGirba 8/21/2011 08:56'!
openExplorerFor: anObject
	"this method is needed for compatibility with ObjectExplorer"
	self openOn: anObject! !

!GTInspector methodsFor: 'scripting opening' stamp: 'TudorGirba 4/3/2015 12:53'!
openOn: aPage
	| window |
	window := super openOn: aPage.
	window extent: self class preferredExtent.
	window when: WindowResizing do: [ 
		(window isMinimized or: [ window isMaximized ]) ifFalse: [ 
			"we only wnat to react to real resizing,
			not to minization or maximization"
			self class setPreferredExtentIfWanted: window extent ] ].
	^ window! !

!GTInspector methodsFor: 'accessing' stamp: 'TudorGirba 3/17/2014 16:30'!
panes
	^ self first panes! !

!GTInspector methodsFor: 'context' stamp: 'AndreiChis 12/9/2014 22:40'!
presentationFilter

	^ presentationFilter! !

!GTInspector methodsFor: 'context' stamp: 'AndreiChis 1/14/2015 16:08'!
presentationFilter: aPresentationFilterStragery
	"Set a filter for limiting the number of visible presentations."
	presentationFilter := aPresentationFilterStragery! !

!GTInspector methodsFor: 'accessing' stamp: 'AndreiChis 8/21/2014 23:37'!
previousEntity
	^ self entities reverse second! !

!GTInspector methodsFor: 'accessing' stamp: 'AndreiChis 8/22/2014 01:29'!
previousEntityTo: anObject
	| entities index |
	entities := self entities.
	index := entities indexOf: anObject.
	^ index < 2 
		ifTrue: [ nil ]
		ifFalse: [ entities at: index - 1 ]! !

!GTInspector methodsFor: 'private' stamp: 'SvenVanCaekenberghe 10/6/2014 16:16'!
printObjectAsAnItem: anObject
	| header printString |
	header := (anObject class name first isVowel
		ifTrue: [ 'an ' ]
		ifFalse: [ 'a ' ]) , anObject class name.
	printString := (GTObjectPrinter new asTruncatedTextFrom: anObject) asString.
	^ (printString beginsWith: header)
		ifTrue: [ printString ]
		ifFalse: [ 
			String streamContents: [ :out | 
				out << header; << ' ('; << printString; << ')' ] ]! !

!GTInspector methodsFor: 'actions' stamp: 'AndreiChis 10/5/2014 21:28'!
removeLastPane
	| lastPane |
	
	lastPane := self first panes last.
	self first removeLastPane.
	self first announce: (GLMPaneRemoved pane: lastPane fromBrowser: self first).
	self first panes last updateToolbar! !

!GTInspector methodsFor: 'context' stamp: 'AndreiChis 1/14/2015 14:20'!
shouldDisplayPresentationCreateBy: aMethod
	"Verify whether or not the presentation created by the given method should be displayed.
	If no filter is given display all presentations."
	^ self presentationFilter 
		ifNil: [ true]
		ifNotNil: [ self presentationFilter shouldDisplayPresentationCreateBy: aMethod ]! !

!GTInspector methodsFor: 'scripting' stamp: 'AndreiChis 8/18/2014 19:32'!
showFirst: aBlock

	self first showFirst: aBlock! !

!GTInspector methodsFor: 'actions' stamp: 'AndreiChis 10/29/2014 14:43'!
updatePanesFor: anObject

	(self panes select: [ :each | 
		(each port: #entity) value == anObject ]) do: [ :each | each update ]! !

GLMCompositePresentation subclass: #GTObjectVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectVariablesBrowser commentStamp: 'TudorGirba 8/22/2011 12:52' prior: 0!
This is a helper browser for the main view in the GTInspector.

Example:
self openOn: Smalltalk!

!GTObjectVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 10/22/2014 14:39'!
compose
	self title: 'Raw'.
	self tabulator with: [ :browser |
		browser row: #variables; row: #evaluator.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit to: #evaluator; andShow: [:a | 
			self evaluatorIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection; transformed: [:assoc | assoc ifNotNil: [assoc value]].
		browser transmit from: #evaluator; toOutsidePort: #selection ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 10/17/2014 15:28'!
evaluatorIn: composite
	^ composite pharoPlayground
		doItReceiver: #yourself;
		display: [ :object | 
			String streamContents: [ :stream | 
				stream 
					nextPutAll: (self printStringOf: object);
					cr;
					nextPutAll: (GTSnippets snippetAt: object class)] ];
		onChangeOfPort: #text act: [ :text :object |
				GTSnippets 
					snippetAt: object class 
					put: (self stringWithoutInitialCommentFrom: text text asString) ];
		installGoAction;
		installDefaultSelectionActions! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 8/4/2014 21:26'!
iconFor: anObject
		
	^ [ (anObject iconOrThumbnailOfSize: 16)
		ifNil: [ anObject class systemIcon ] ]
			on: Error do: [ :error |
			self iconFor: anObject error: error ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 8/4/2014 21:25'!
iconFor: anEyeElement error: error
	^ Smalltalk ui icons smallWarningIcon! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 8/28/2014 19:52'!
printStringOf: anObject
	^ [(anObject printString contractTo: 200) asComment] 
			on: Error 
			do: ['"Error printing. Try self printString to debug"']! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'SeanDeNigris 4/28/2015 08:52'!
stringWithoutInitialCommentFrom: aString
	^ (aString trimLeft isEmpty not and: [ aString trimLeft first = $" ])
		ifFalse: [ aString trimBoth ]
		ifTrue: [|startIndex|
			startIndex := aString findAnySubstring: '"' startingAt: (aString indexOf: $") + 1.
			(startIndex = (aString size + 1)) ifTrue: [ "No content if a comment cannot be identified. " ^ '' ].
			(aString
				copyFrom: startIndex + 1 
				to: aString size) trimBoth ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'MarcusDenker 1/16/2015 08:26'!
updateInstanceVariable: aSymbol from: anObject basedOn: aString
	|result|

	(anObject class hasInstVarNamed: aSymbol) 
		ifFalse: [ ^ self ].
	result := anObject class compiler
			source: aString;
			context: nil;
			receiver: anObject;
			failBlock: [ ^ self ];
			evaluate.
						
	anObject writeSlotNamed: aSymbol value: result.
	! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TommasoDalSasso 1/30/2015 16:09'!
variableValuePairsFor: anObject

	^ anObject gtInspectorVariableValuePairs asOrderedCollection 
		yourself! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 4/2/2015 19:00'!
variablesIn: composite
	^ composite table
		showOnly: 50;
		shouldValidate: false;
		allowsRecursiveSearch: false;
		"wantsSteps: true;"
		children: [ :assoc | assoc key = 'self'
			ifTrue: [ #() ]
			ifFalse: [ self variableValuePairsFor: assoc value ] ];
		icon: [ :assoc | self iconFor: assoc value ];
		display: [ :anObject | (self variableValuePairsFor: anObject)
				addFirst: 'self' -> anObject;
				yourself ];
		column: 'Variable' 
			evaluated: [:assoc | '  ',(GTObjectPrinter new asNonTruncatedTextFrom: assoc key) ];
		column: 'Value' 
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ]
			modified: [:newValue :assoc :presentation | 
				self updateInstanceVariable: assoc key from: presentation entity basedOn: newValue.
				presentation update ];
		"send: #value;"
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect';
		selectionAct: [:list | 
			((list selection pointersToExcept: { list selection })
									reject: [ :each | each pointsOnlyWeaklyTo: list selection ]) inspect ] 
			on: $t
			entitled: 'Open pointers to'! !

GLMCompositePresentation subclass: #GTSimpleMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleMethodsBrowser commentStamp: 'TudorGirba 1/18/2014 14:29' prior: 0!
This browser is used to browse the class structure of every object in the inspector.

Example:
self openOn: World!

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 11/24/2013 08:37'!
accumulatedSourceOf: m for: object in: composite
	composite accumulator with: [ :acc | 
		acc show: [ :a |
			a title: [ :method | method selector ].
			self sourceOf: m for: object in: a ] ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'MarcusDenker 8/11/2015 16:29'!
classesIn: a
	^ a list
		display: [ :object | 
			| all |
			all := OrderedCollection new.
			object class withAllSuperclassesDo: [:each | all add: each ].
			all ];
"		initialize: [ :list | list selection: list entity class ];"
		format: [ :class | class name ];
		morphicSelectionAct: [ :list | Smalltalk tools browser openOnClass: list selection ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse'! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 3/9/2014 08:59'!
compose
	self title: 'Meta'.
	self tabulator with: [ :browser |
		browser
			row: [ :r | r column: #classes; column: #methods span: 3 ];
			row: #source.
		browser transmit
			to: #classes;
			andShow: [ :a | self classesIn: a ].
		browser transmit
			to: #classes port: #selection;
			transformed: [:each | each class ].
		browser transmit
			fromOutsidePort: #entity;
			from: #classes;
			to: #methods;
			andShow: [ :a | self methodsIn: a ].
		browser transmit
			from: #methods;
			fromOutsidePort: #entity;
			to: #source;
			when: [ :method | method notNil ];
			andShow: [ :a :method :object | self sourceOf: method for: object in: a ].
		browser transmit
			toOutsidePort: #selection;
			from: #methods port: #evaluatedObject.
		browser transmit
			toOutsidePort: #selection;
			from: #source port: #evaluatedObject.
	]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 10/3/2014 15:14'!
evaluationAction
	^ GLMGenericAction new
		action: [ :listPresentation :obj | 
					| result |
					result := obj perform: listPresentation selection selector.
					(listPresentation pane port: #evaluatedObject) value: result ];
		shortcut: $g;
		title: 'Do it and go';
		yourself! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 7/15/2012 18:58'!
methodActionsFor: aMethod
	^ aMethod selector isUnary
		ifTrue: [ Array with: self evaluationAction ]
		ifFalse: [ #() ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'MarcusDenker 8/11/2015 16:39'!
methodsIn: a
	^ a list
		display: [ :object :class | class methods collect: #asRingDefinition];
		filterOn: [ :text :each | (text , '*') match: each selector ];
		tags: [ :method | method category ];
		sorted: [ :method1 :method2 | method1 selector < method2 selector ];
		format: [ :method | method selector ];
		morphicSelectionAct: [ :list :object :class | 
			Smalltalk tools browser 
				openOnClass: class 
				selector: list selection selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse';
		dynamicActionsOnSelection: [ :list | self methodActionsFor: list selection ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'MarcusDenker 8/11/2015 16:39'!
sourceOf: method for: object in: composite
	^ composite smalltalkCode
		display: [ :m | m sourceCode ];
		smalltalkClass: [ :m | m methodClass ];
		doItReceiver: [ object ];
		selectionPopulate: #evaluatedObject
			on: $g
			entitled: 'Do it and go'
			with: [ :text | Smalltalk compiler evaluate: text selectedText for: object logged: false ];
		act: [ :text :m | self updateOuterPaneFrom: text for: method ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept';
		act: [ :text :m | 
			Smalltalk tools browser 
				openOnClass: m methodClass 
				selector: m selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		act: [ :text :m | 
			(text pane port: #evaluatedObject) value: m ]
			icon: GLMUIThemeExtraIcons glamorousInspect
			entitled: 'Inspect'! !

!GTSimpleMethodsBrowser methodsFor: 'private' stamp: 'AndreiChis 1/24/2015 16:10'!
updateOuterPaneFrom: text for: method
	"this is a utility method to tell the pane surrounding the browser to update.
	The reason we do that is to support the use case of updating the GTInspector from
	the editor by modifying code directly in the Inspector."
	
	| outerPane newMethod |
	newMethod := method methodClass compile: text text notifying: nil.
	outerPane := text pane browser pane.
	outerPane browser panes do: #update.
	self
		flag:
			'This is a huge hack because of so many reasons:
				- the presentation accesses the state of the outer browser directly
				- the presentation depends on the implementation of the browser 
				It should be solved through transmissions.
				
				But, it works for now and the browser is reasonably updated'.
	^ outerPane
		withAllPanesAndPresentationsDo: [ :child | 
			(child isKindOf: self class)
				ifTrue: [ 
					((child first paneNamed: #classes) port: #selection) value: method methodClass.
					((child first paneNamed: #methods) port: #selection)
						value:
							((child first paneNamed: #methods) presentations first displayedValue detect: [ :each | each selector = newMethod ]) ] ]! !

!Exception methodsFor: '*GT-Inspector-Examples-Exceptions' stamp: 'StefanReichhart 7/13/2015 11:27'!
isExampleError
	^ false! !

!Pragma methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:58'!
isGTExamplePragma
	<todo: 'deprecated: #gtExample:'>
	^ self keyword = #gtExample
		or: [ self keyword = #gtExample: ]! !

!ExceptionSet methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 6/15/2015 16:56'!
copyWith: anException
	^ self class new 
		instVarNamed: #exceptions put: (exceptions copyWith: anException);
		yourself! !

!ExceptionSet methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 7/13/2015 11:18'!
copyWithAll: anExceptionSet
	^ self class new 
		instVarNamed: #exceptions put: (exceptions copyWithAll: (anExceptionSet instVarNamed: #exceptions));
		yourself! !

!ExceptionSet methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 17:43'!
signaledBy: anException
	(anException isNil and: [ exceptions isEmptyOrNil not ]) ifTrue: [ 
		^ (GTExampleExpectedExceptionNotRaised new 
			expectedError: self;
			exception: anException;
			yourself) signal ].
	(anException notNil and: [ (exceptions includes: anException class) not ]) ifTrue: [ 
		^ (GTExampleUnexpectedExceptionRaised new
			unexpectedError: anException;
			yourself) signal ]! !

Object subclass: #GTExample
	instanceVariableNames: 'source provider finder pragma label description form exceptions subjects parents children result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Core'!

!GTExample commentStamp: 'TudorGirba 9/6/2015 11:03' prior: 0!
I represent the concept of an example.

I am constructed out of a method that returns an object. I hold the meta-information about that method and I know how to construct the concrete resulting object that is returned by the method. 

I can depend on other examples, and other examples can depend on me. When I depend on another example, the code that produces me uses the result of the other example to construct me.

The class for which I represent the example is called my subject.

The class that offers the method out of which I am constructed is the provider.

I also know how to handle possible exceptions, which makes me a great candidate for encoding assumptions that are otherwise expressed as classic tests.!

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/2/2015 12:06'!
= anExample
	^ self class = anExample class 
		and: [ self pragma = anExample pragma 
			and: [ self method = anExample method
				and: [ self method selector = anExample method selector
					and: [ self method methodClass = anExample method methodClass ] ] ] ]! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/24/2015 21:38'!
allDependencies
	| examples |
	examples := Set new.
	(self traverser
		action: [ :example | examples add: example ];
		yourself) value.
	^ examples! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/24/2015 21:35'!
allDependents
	| examples |
	examples := Set new.
	(self traverser reversed
		action: [ :example | examples add: example ];
		yourself) value.
	^ examples! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/24/2015 20:54'!
arguments
	^ children asArray! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 8/24/2015 20:58'!
children
	^ children! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
childrenExamples
	<todo: 'deprecated: #childrenExamples'>
	^ self dependencies! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/29/2015 11:03'!
classNamed: aClassOrClassName
	^ aClassOrClassName isClass 
		ifTrue: [ aClassOrClassName ]
		ifFalse: [ Smalltalk classNamed: aClassOrClassName asString ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:44'!
classNamed: aClassName do: aBlock
	^ self classNamed: aClassName do: aBlock ifNone: [ 
		(GTExampleDeclaredClassMissing new
			example: self;
			classNamed: aClassName;
			yourself) signal ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:04'!
classNamed: aClassName do: aBlock1 ifNone: aBlock2
	^ (self classNamed: aClassName)
		ifNotNil: aBlock1
		ifNil: aBlock2! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 9/2/2015 22:19'!
debug
	^ self debugger result! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 17:42'!
debugger
	^ GTExampleDebugger new 
		example: self;
		yourself! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/23/2015 12:36'!
dependencies
	^ self arguments collect: [ :each | each example ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 20:54'!
dependenciesOrErrors
	^ self arguments collect: [ :each | 
		[ each example ] 
			on: Error 
			do: [ :exception | exception ] ]! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/25/2015 22:01'!
dependents
	^ self parents asArray collect: [ :each | each owner ]! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 9/6/2015 17:46'!
depends: aSelector
	children add: (GTExampleProxy new
		owner: self;
		provider: self provider;
		selector: aSelector asSymbol;
		yourself)! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 9/4/2015 13:40'!
dependsAll: aString
	self substrings: aString do: [ :each | 
		self depends: aString ]! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 9/6/2015 17:46'!
dependsClass: aClassOrClassName selector: aSelector
	self classNamed: aClassOrClassName do: [ :class | 
		children add: (GTExampleProxy new
			owner: self;
			provider: class gtExamplesProvider; " we have to resolve the kind of example again - it could be implemented in #class or in the provider of #class !! "
			selector: aSelector asSymbol;
			yourself) ]! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/7/2015 17:39'!
description
	^ description! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 6/7/2015 17:39'!
description: anObject
	description := anObject! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 13:48'!
detachFromSystem
	(self traverser reversed
		action: [ :example | example detachResultFromSystem ];
		onRecursionError: [ :aProcessor :anExample | " ignore and continue " ];
		yourself) value.
	children do: [ :proxy | proxy detachFromSystem ].
	parents do: [ :proxy | proxy detachFromSystem ].
	children := OrderedCollection new.
	parents := Set new.! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 13:47'!
detachResultFromSystem
	result ifNil: [ ^ self ].
	result detachFromSystem.
	result := nil.! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 19:58'!
equalsExample: anExampleOrExampleProxy
	^ anExampleOrExampleProxy isGTExample
		ifTrue: [ self class = anExampleOrExampleProxy class and: [ self = anExampleOrExampleProxy ] ]
		ifFalse: [ anExampleOrExampleProxy equalsExample: self ]! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 17:42'!
evaluator
	^ GTExampleEvaluator new 
		example: self;
		yourself! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/2/2015 11:52'!
example
	^ self! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/29/2015 10:58'!
exceptions
	^ exceptions! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2015 12:42'!
exists
	^ self method methodClass includesSelector: self method selector! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
extractionStrategy
	<todo: 'deprecated: #extractionStrategy'>
	self shouldNotImplement! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
extractionStrategy: anObject
	<todo: 'deprecated: #extractionStrategy:'>
	self shouldNotImplement! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/17/2015 14:56'!
finder 
	^ finder! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 7/18/2015 19:40'!
gtDebuggerSourceIn: composite
	<gtDebuggerPresentationOrder: 1>
	self method gtInspectorSourceIn: composite! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 14:18'!
gtDisplayOn: aStream
	self printOn: aStream.
	aStream nextPutAll: ' ('.
	self gtDisplaySummaryOn: aStream.
	aStream nextPutAll: ')'! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 18:03'!
gtDisplaySourceIn: composite
	<todo: 'deprecated: #gtDisplaySourceIn:'>
	^ self gtInspectorSourceIn: composite! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 13:46'!
gtDisplaySummaryOn: aStream.
	self label isEmptyOrNil 
		ifFalse: [ ^ aStream nextPutAll: self label ].
	self description isEmptyOrNil 
		ifFalse: [ ^ aStream nextPutAll: self description ].
	aStream nextPutAll: self method name! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 9/6/2015 16:59'!
gtExample
	^ self! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 17:31'!
gtExample: anObject
	<todo: 'deprecated: #gtExample:'>
	self label: anObject.
	^ self gtExample! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 17:31'!
gtExampleFrom: aSelector
	<todo: 'deprecated: #gtExampleFrom:'>
	^ self depends: aSelector! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 9/2/2015 20:55'!
gtInspectorActionEvaluateResultAndGo
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ :p | p selection: self result ];
		icon: Smalltalk ui icons glamorousRight;
		title: 'Evaluate result and go'! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 9/2/2015 20:55'!
gtInspectorDependenciesIn: composite
	<gtInspectorPresentationOrder: 2>
	^ ((self dependenciesOrErrors ifEmpty: [ ^ self ]) 
			gtInspectorItemsIn: composite)
				title: 'Dependencies'! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/29/2015 18:09'!
gtInspectorDependentsIn: composite
	<gtInspectorPresentationOrder: 3>
	^ ((self dependents ifEmpty: [ ^ self ]) 
			gtInspectorItemsIn: composite)
				title: 'Dependents'! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/31/2015 22:55'!
gtInspectorRoassalIn: composite
	<gtInspectorPresentationOrder: 1>
	^ self painter gtInspectorRoassalIn: composite! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 14:14'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 0>
	^ (self method gtInspectorSourceIn: composite)
		title: 'Source'! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/24/2015 21:30'!
gtSpotterDependenciesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Example Dependencies';
		allCandidates: [ self arguments ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/24/2015 21:30'!
gtSpotterDependentsFor: aStep
	<spotterOrder: 101>
	aStep listProcessor
		title: 'Example Dependents';
		allCandidates: [ self dependents ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 13:58'!
gtSpotterPreviewIn: aComposite
	<spotterPreview: 1>
	^ aComposite pharoMethod
		title: [ self gtDisplayString ]; 
		display: [ :entity | entity method sourceCode ];
		smalltalkClass: [ self method methodClass ];
		entity: self! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/26/2015 20:57'!
hasDependency: anExample
	(self traverser
		action: [ :example | (example equalsExample: anExample) ifTrue: [ ^ true ] ];
		yourself) value.
	^ false! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/26/2015 20:57'!
hasDependent: anExample
	(self traverser reversed
		action: [ :example | (example equalsExample: anExample) ifTrue: [ ^ true ] ];
		yourself) value.
	^ false! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
hasParentExample
	<todo: 'deprecated: #hasParentExample'>
	^ self dependents notEmpty! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 9/4/2015 16:30'!
hasSubject: aSubject
	^ self classNamed: aSubject do: [ :class | self subjects includes: class ] ifNone: [ false ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/29/2015 20:21'!
hasValidArguments
	^ self arguments size = self method numArgs! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/29/2015 20:24'!
hasValidDependencies
	[ self dependencies ]
		on: Error
		do: [ ^ false ].
	^ true! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 6/22/2015 16:23'!
hash
	^ (((self class hash 
		bitXor: self pragma hash) 
			bitXor: self method hash)
				bitXor: self method selector hash)
					bitXor: self method methodClass hash! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 9/4/2015 16:51'!
icon
	^ form! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 6/7/2015 18:59'!
icon: aSelector
	self iconThemeSelector: aSelector! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:02'!
iconBase64: aString
	form := (Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: aString readStream))! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:02'!
iconBytes: aByteArray
	form := (Form
		extent: 16@16
		depth: 32
		fromArray: aByteArray 
		offset: 0@0)! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:35'!
iconClass: aClassOrClassName selector: aSelector
	self classNamed: aClassOrClassName do: [ :class | 
		form := (class perform: aSelector) ]! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:02'!
iconSelector: aSelector
	form := (self provider perform: aSelector)! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:02'!
iconThemeSelector: aSelector
	form := (Smalltalk ui icons perform: aSelector)! !

!GTExample methodsFor: 'initializing' stamp: 'StefanReichhart 8/24/2015 21:48'!
initializeFromFinder: aFinder withPragma: aPragma
	finder := aFinder.
	pragma := aPragma.
	source := aFinder source.
	provider := aFinder provider.
	subjects := aFinder subjects.
	exceptions := ExceptionSet new.
	children := OrderedCollection new.
	parents := Set new.
	
	aPragma method pragmas do: [ :p |
		(self class canPerform: p keyword) 
			ifTrue: [ self perform: p keyword withArguments: p arguments ] ].! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 17:57'!
isGTExample
	^ true! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 12:37'!
isValid
	^ self traverser canProcess! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/7/2015 17:39'!
label
	^ label! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 6/7/2015 17:39'!
label: anObject
	label := anObject! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2015 12:41'!
matchesMethod: aCompiledMethod
	^ aCompiledMethod class = CompiledMethod
		and: [ self method methodClass = aCompiledMethod methodClass
			and: [ self method selector = aCompiledMethod selector ] ]! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 6/21/2015 20:38'!
method
	^ self pragma method! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
methodReference
	<todo: 'deprecated: #methodReference'>
	^ self method asRingDefinition! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 17:45'!
painter
	^ GTExamplePainter new 
		example: self;
		yourself! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
parentExample: anObject
	<todo: 'deprecated: #parentExample:'>
	^ self shouldNotImplement! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 8/24/2015 20:58'!
parents
	^ parents! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/7/2015 17:57'!
pragma
	^ pragma! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/17/2015 12:44'!
provider
	^ provider! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:35'!
raises: aClassOrClassName
	self classNamed: aClassOrClassName do: [ :class | 
		self exceptions add: class ]! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:35'!
raisesAny: aString
	self substrings: aString do: [ :each | 
		self raises: each ]! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 8/24/2015 21:47'!
result
	^ result ifNil: [ self run ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 13:46'!
result: aResult
	result := aResult! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/2/2015 12:00'!
returnValue
	^ self result returnValue! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 8/24/2015 21:47'!
run
	^ result := self evaluator result ! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
selector
	<todo: 'deprecated: #selector'>
	^ self shouldNotImplement! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:29'!
selector: aSelector
	<todo: 'deprecated: #selector:'>
	^ self shouldNotImplement! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:19'!
source
	^ source! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 18:37'!
sourceCode
	^ self method sourceCode! !

!GTExample methodsFor: 'ui' stamp: 'StefanReichhart 9/6/2015 18:06'!
spotterPreviewIn: aComposite inContext: aSpotter
	<todo: 'deprecated: #spotterPreviewIn:inContext:'>
	^ self gtSpotterPreviewIn: aComposite
	"
	^ self result spotterPreviewIn: aComposite inContext: aSpotter
	"! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:35'!
subject: aClassOrClassName
	self classNamed: aClassOrClassName do: [ :class | 
		self subjects add: class ]! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/29/2015 11:00'!
subjects
	^ subjects! !

!GTExample methodsFor: 'pragma-selectors' stamp: 'StefanReichhart 7/29/2015 11:03'!
subjectsAll: aString
	self substrings: aString do: [ :each | 
		self subject: each ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:09'!
substrings: aString do: aBlock
	(aString substrings: ' .,;') do: [ :each | 
		aBlock value: each trimBoth ]! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 18:01'!
title
	<todo: 'deprecated: #title'>
	^ self gtDisplayString
	"
	^ title 
		ifNil: [ self result ]
		ifNotNil: [ title ]
	"! !

!GTExample methodsFor: '*GT-Inspector-Examples-DEPRECATED' stamp: 'StefanReichhart 9/6/2015 22:24'!
title: aString
	<todo: 'deprecated: #title:'>
	self label: aString
	"
	title: aString
		title := aString
	"! !

!GTExample methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 17:42'!
traverser
	^ GTExampleTraverser new 
		example: self;
		yourself! !

Object subclass: #GTExampleFinder
	instanceVariableNames: 'source provider subjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Utils'!

!GTExampleFinder class methodsFor: 'public' stamp: 'StefanReichhart 9/7/2015 21:42'!
gtExampleInstance
	<gtExample>
	<label: 'An example finder on the source/provider #Number'>
	
	^ self new
		source: Number;
		provider: Number;
		subjects: #();
		yourself! !

!GTExampleFinder class methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 16:45'!
gtExamples
	" self gtExamples "
	| examples |
	examples := OrderedCollection new.
	self gtExamplesTo: examples.
	^ examples! !

!GTExampleFinder class methodsFor: 'public' stamp: 'StefanReichhart 9/7/2015 22:24'!
gtExamplesTo: examples
	<todo: 'fix the #gtExamples for the finder'>
	(Object withAllSubclasses difference: self withAllSubclasses) do: [ :class | 
		class gtExamplesFinder ifNotNil: [ :finder | 
			finder gtExamplesTo: examples ] ]! !

!GTExampleFinder class methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 22:42'!
myExamples
	" self myExamples "
	| examples |
	examples := OrderedCollection new.
	self myExamplesTo: examples.
	^ examples! !

!GTExampleFinder class methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 23:00'!
myExamplesTo: examples
	Object withAllSubclasses do: [ :class | 
		class gtExamplesFinder ifNotNil: [ :finder | 
			self = finder class ifTrue: [ 
				finder myExamplesTo: examples ] ] ]! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 19:34'!
class: aClass selector: aSelector method: aMethod pragma: aPragma
	^ GTExampleOrganizer instance atMethod: aMethod ifAbsentPut: [ self newExampleFromPragma: aPragma ]! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 16:59'!
class: aClass selector: aSelector method: aMethod to: examples
	(aMethod pragmas 
		detect: [ :pragma | pragma isGTExamplePragma ]
		ifNone: [ nil ]) ifNotNil: [ :pragma |
			self example: (self class: aClass selector: aSelector method: aMethod pragma: pragma) to: examples ] ! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:44'!
class: aClass selector: aSelector to: examples
	(aClass includesSelector: aSelector) ifFalse: [ 
		^ (GTExampleDeclaredMethodMissing new
			methodClass: aClass;
			selector: aSelector;
			yourself) signal ].
	self class: aClass selector: aSelector method: aClass >> aSelector to: examples! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 6/17/2015 12:52'!
class: aClass to: examples
	aClass selectorsAndMethodsDo: [ :selector :method | 
		self class: aClass selector: selector method: method to: examples ] ! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 8/25/2015 20:45'!
example: anExample to: examples
	(examples anySatisfy: [ :each | each equalsExample: anExample ]) ifTrue: [ ^ self ].
	examples add: anExample! !

!GTExampleFinder methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 16:42'!
gtExamples
	| examples |
	examples := OrderedCollection new.
	self gtExamplesTo: examples.
	^ examples! !

!GTExampleFinder methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 16:42'!
gtExamplesTo: examples
	self class: self provider class to: examples! !

!GTExampleFinder methodsFor: 'ui' stamp: 'StefanReichhart 9/6/2015 16:36'!
gtSpotterExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ self gtExamples ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 6/17/2015 12:52'!
method: aMethod to: examples
	self class: aMethod methodClass selector: aMethod selector method: aMethod to: examples! !

!GTExampleFinder methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 23:01'!
myExamples
	^ self gtExamples! !

!GTExampleFinder methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 23:01'!
myExamplesTo: examples
	self gtExamplesTo: examples! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 19:49'!
newExample
	^ GTExample new! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 19:49'!
newExampleFromPragma: aPragma
	^ self newExample
		initializeFromFinder: self withPragma: aPragma;
		yourself ! !

!GTExampleFinder methodsFor: 'accessing' stamp: 'StefanReichhart 6/17/2015 12:30'!
provider
	^ provider! !

!GTExampleFinder methodsFor: 'accessing' stamp: 'StefanReichhart 6/17/2015 12:31'!
provider: anObject
	provider := anObject! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 8/23/2015 12:41'!
proxy: anExampleProxy
	| examples |
	examples := OrderedCollection new.
	self class: anExampleProxy provider class selector: anExampleProxy selector to: examples.
	^ examples first! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 8/29/2015 11:12'!
proxy: anExampleProxy matchesMethod: aCompiledMethod
	^ aCompiledMethod class = CompiledMethod
		and: [ anExampleProxy provider class = aCompiledMethod methodClass
			and: [ anExampleProxy selector = aCompiledMethod selector ] ]! !

!GTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 8/29/2015 11:09'!
proxyExists: anExampleProxy
	^ anExampleProxy provider class includesSelector: anExampleProxy selector! !

!GTExampleFinder methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:28'!
source
	^ source! !

!GTExampleFinder methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:28'!
source: anObject
	source := anObject! !

!GTExampleFinder methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 13:25'!
subjects
	^ subjects ifNil: [ 
		source 
			ifNotNil: [ OrderedCollection with: source ]
			ifNil: [ OrderedCollection new ] ].! !

!GTExampleFinder methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 13:26'!
subjects: anObject
	subjects := anObject ifNotNil: [ anObject asOrderedCollection ]! !

Object subclass: #GTExampleImpostorPragma
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Utils'!

!GTExampleImpostorPragma methodsFor: 'comparing' stamp: 'StefanReichhart 9/6/2015 19:01'!
= aImpostorPragma
	^ self class = aImpostorPragma class
		and: [ self method = aImpostorPragma method ]! !

!GTExampleImpostorPragma methodsFor: 'accessing-method' stamp: 'StefanReichhart 9/6/2015 18:59'!
arguments
	^ #()! !

!GTExampleImpostorPragma methodsFor: 'comparing' stamp: 'StefanReichhart 9/6/2015 19:30'!
hash
	^ self method hash! !

!GTExampleImpostorPragma methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 19:02'!
isGTExamplePragma
	^ true! !

!GTExampleImpostorPragma methodsFor: 'accessing-method' stamp: 'StefanReichhart 9/6/2015 19:00'!
keyword
	^ #gtExample! !

!GTExampleImpostorPragma methodsFor: 'accessing-method' stamp: 'StefanReichhart 9/6/2015 18:58'!
method
	^ method! !

!GTExampleImpostorPragma methodsFor: 'accessing-method' stamp: 'StefanReichhart 9/6/2015 18:58'!
method: anObject
	method := anObject! !

!GTExampleImpostorPragma methodsFor: 'accessing-method' stamp: 'StefanReichhart 9/6/2015 18:59'!
methodClass
	^ method methodClass! !

!GTExampleImpostorPragma methodsFor: 'accessing-method' stamp: 'StefanReichhart 9/6/2015 18:59'!
selector
	^ method selector! !

Object subclass: #GTExampleNautilus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-UI'!

!GTExampleNautilus methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 22:01'!
examples: aCollection
	^ aCollection size = 1
		ifTrue: [ aCollection first ]
		ifFalse: [ aCollection ]! !

!GTExampleNautilus methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 22:00'!
examples: aCollection do: aSelector
	^ aCollection size = 1
		ifTrue: [ aCollection first perform: aSelector ]
		ifFalse: [ aCollection collect: aSelector ]! !

!GTExampleNautilus methodsFor: 'public' stamp: 'StefanReichhart 9/7/2015 23:15'!
onClass: aBuilder
	| target class examples |
	target := aBuilder model.
	(class := target selectedClass) ifNil: [ ^ self ].
	self onReferences: class theNonMetaClass name builder: aBuilder.
	(examples := class gtExamplesContained) isEmptyOrNil ifTrue: [ ^ self ].
	self onExamples: examples builder: aBuilder! !

!GTExampleNautilus methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 16:37'!
onCompiledMethod: aBuilder
	| target method examples |
	target := aBuilder model.
	(method := target selectedMethod) ifNil: [ ^ self ].
	self onReferences: method selector builder: aBuilder.
	(examples := method gtExamplesContained) isEmptyOrNil ifTrue: [ ^ self ].
	self onExamples: examples builder: aBuilder
! !

!GTExampleNautilus methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 22:01'!
onExamples: aCollection builder: aBuilder
	(aBuilder item: #'Inspect Examples')
		order: 10000;
		action: [ (self examples: aCollection) inspect ].

	(aBuilder item: #'Run Examples')
		order: 10000;
		action: [ (self examples: aCollection do: #result) inspect ].
		
	(aBuilder item: #'Debug Examples')
		order: 10000;
		action: [ (self examples: aCollection do: #debug) ].
		
		! !

!GTExampleNautilus methodsFor: 'public' stamp: 'StefanReichhart 9/6/2015 16:37'!
onPackage: aBuilder
	| target package examples |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^ self ].
	package item ifNil: [ ^ self ].
	(examples := package item gtExamplesContained) isEmptyOrNil ifTrue: [ ^ self ].
	self onExamples: examples builder: aBuilder! !

!GTExampleNautilus methodsFor: 'public' stamp: 'StefanReichhart 9/4/2015 16:26'!
onReferences: aLiteral builder: aBuilder
	(aBuilder item: #'Examples of ...')
		order: 10000;
		action: [
			(SystemNavigation default examplesReferencesTo: aLiteral) 
				ifNotEmpty: [ :examples | examples inspect ]
				ifEmpty: [ UIManager default inform: 'No examples found for #', aLiteral asString ] ].
				
! !

Object subclass: #GTExampleOrganizer
	instanceVariableNames: 'running examples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Utils'!

GTExampleOrganizer class
	instanceVariableNames: 'instance'!

GTExampleOrganizer class
	instanceVariableNames: 'instance'!

!GTExampleOrganizer class methodsFor: 'examples' stamp: 'StefanReichhart 9/7/2015 21:41'!
gtExampleInstance
	<gtExample>
	<label: 'An instance of an example organizer'>
	
	^ GTExampleOrganizer instance! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 9/7/2015 21:42'!
instance
	^ instance ifNil: [ instance := self basicNew initialize start ]! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 9/7/2015 21:42'!
new
	self shouldNotImplement! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 6/21/2015 17:03'!
restart
	self stop.
	self start.! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 6/21/2015 16:21'!
start
	self instance start! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 6/21/2015 16:20'!
stop
	instance ifNotNil: [ instance stop ].
	instance := nil! !

!GTExampleOrganizer methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 12:58'!
atMethod: aCompiledMethod ifAbsentPut: aBlock
	<todo: '#theNonMetaClass is not good'>
	^ (examples at: aCompiledMethod methodClass theNonMetaClass name ifAbsentPut: [ IdentityDictionary new ]) 
		at: aCompiledMethod selector 
		ifAbsentPut: aBlock! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 9/4/2015 17:06'!
categoryRemoved: anAnnouncement
	self withCleanupDo: [ 
		examples keys do: [ :key |
			(Smalltalk classNamed: key) ifNil: [ 
				(examples removeKey: key ifAbsent: [ nil ]) ifNotNil: [ :dict | 
					dict do: #detachFromSystem ] ] ].
		
		self checkForMissingDependencies.
		self checkForMissingClasses ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 21:02'!
checkForDependenciesUsing: aCompiledMethod
	[ self examples do: [ :example |
		example arguments do: [ :dependency |
			(dependency exists not and: [ dependency matchesMethod: aCompiledMethod ]) 
				ifTrue: [ self notifyForDependencyUsing: aCompiledMethod example: example ] ] ] ]
		on: Error
		do: [ :exception | " ignore " ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:44'!
checkForMissingClasses
	[ self examples ]
		on: GTExampleDeclaredClassMissing
		do: [ :exception | 
			self notifyForMissingClasses: exception ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:44'!
checkForMissingClasses: aCompiledMethod
	[ aCompiledMethod gtExamples ]
		on: GTExampleDeclaredClassMissing
		do: [ :exception | 
			self notifyForMissingClasses: exception ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 16:43'!
checkForMissingDependencies
	[ self examples do: [ :example | 
		example arguments do: [ :dependency | 
			dependency exists 
				ifFalse: [ self notifyForMissingDependency: dependency example: example ] ] ] ]
		on: Error
		do: [ :exception | " ignore " ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 16:35'!
checkForMissingDependencies: aCompiledMethod
	[ aCompiledMethod gtExamples do: [ :example | 
		example arguments do: [ :dependency | 
			dependency exists 
				ifFalse: [ self notifyForMissingDependency: dependency example: example ] ] ] ]
		on: Error
		do: [ :exception | " ignore " ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 16:35'!
checkForNumberOfArguments: aCompiledMethod
	[ aCompiledMethod gtExamples do: [ :example | 
		example arguments size = aCompiledMethod numArgs 
			ifFalse: [ self notifyForNumberOfArguments: example ] ] ]
		on: Error
		do: [ :exception | " ignore " ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 9/4/2015 17:06'!
classRemoved: anAnnouncement
	self withCleanupDo: [ 
		(examples removeKey: anAnnouncement classRemoved theNonMetaClass name ifAbsent: [ nil ])
			ifNotNil: [ :dict | dict do: #detachFromSystem ].
			
		self checkForMissingDependencies.
		self checkForMissingClasses ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 8/25/2015 21:08'!
classRenamed: anAnnouncement
	self withCleanupDo: [ 
		examples at: anAnnouncement oldName asSymbol ifPresent: [ :oldValue | 
			examples at: anAnnouncement newName asSymbol put: oldValue ].
		
		self checkForMissingDependencies ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 22:50'!
examples
	^ GTExampleFinder gtExamples! !

!GTExampleOrganizer methodsFor: 'ui' stamp: 'StefanReichhart 9/6/2015 17:03'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ self examples ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleOrganizer methodsFor: 'initializing' stamp: 'StefanReichhart 7/18/2015 19:16'!
initialize
	super initialize.
	
	self reset.! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 8/25/2015 21:08'!
methodAdded: anAnnouncement
	self withCleanupDo: [ 
		self checkForMissingDependencies: anAnnouncement method.
		self checkForNumberOfArguments: anAnnouncement method.
		self checkForMissingClasses: anAnnouncement method ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 8/25/2015 21:08'!
methodModified: anAnnouncement
	self withCleanupDo: [ 
		((examples at: anAnnouncement oldMethod methodClass theNonMetaClass name ifAbsent: [ IdentityDictionary new ])
			removeKey: anAnnouncement oldMethod selector ifAbsent: [ nil ]) detachFromSystem.
			
		self checkForMissingDependencies: anAnnouncement method.
		self checkForNumberOfArguments: anAnnouncement method.
		self checkForMissingClasses: anAnnouncement method.
		self checkForDependenciesUsing: anAnnouncement method ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 8/25/2015 21:08'!
methodRemoved: anAnnouncement
	self withCleanupDo: [ 
		((examples at: anAnnouncement method methodClass theNonMetaClass name ifAbsent: [ IdentityDictionary new ])
			removeKey: anAnnouncement method selector ifAbsent: [ nil ]) detachFromSystem.
			
		self checkForDependenciesUsing: anAnnouncement method ]! !

!GTExampleOrganizer methodsFor: 'private-notify' stamp: 'StefanReichhart 7/18/2015 18:53'!
notify: aString exception: anException
	UIManager default inform: (String streamContents: [ :stream | stream 
		nextPutAll: aString;
		nextPutAll: ': ';
		nextPutAll: anException messageText ])! !

!GTExampleOrganizer methodsFor: 'private-notify' stamp: 'StefanReichhart 7/18/2015 18:53'!
notifyForDependencyUsing: aCompiledMethod example: anExample
	UIManager default inform: (String streamContents: [ :stream | stream 
		nextPutAll: 'Obsolete example dependency in' ;
		cr;
		nextPutAll: anExample method methodClass name asString;
		nextPutAll: ' >> #';
		nextPutAll: anExample method selector asString ])! !

!GTExampleOrganizer methodsFor: 'private-notify' stamp: 'StefanReichhart 7/24/2015 19:00'!
notifyForMissingClasses: anException
	UIManager default inform: (String streamContents: [ :stream | stream 
		nextPutAll: 'Referenced class missing' ;
		cr;
		nextPutAll: anException classNamed asString ])! !

!GTExampleOrganizer methodsFor: 'private-notify' stamp: 'StefanReichhart 8/25/2015 22:01'!
notifyForMissingDependency: aDependency example: anExample
	UIManager default inform: (String streamContents: [ :stream | stream 
		nextPutAll: 'Missing example dependency' ;
		cr;
		nextPutAll: aDependency owner provider class name asString;
		nextPutAll: ' >> #';
		nextPutAll: aDependency selector asString ])! !

!GTExampleOrganizer methodsFor: 'private-notify' stamp: 'StefanReichhart 7/24/2015 17:38'!
notifyForNumberOfArguments: anExample
	UIManager default inform: (String streamContents: [ :stream | stream 
		nextPutAll: 'Invalid number of arguments in' ;
		cr;
		nextPutAll: anExample method methodClass name asString;
		nextPutAll: ' >> #';
		nextPutAll: anExample method selector asString ])! !

!GTExampleOrganizer methodsFor: 'initializing' stamp: 'StefanReichhart 9/6/2015 19:42'!
reset
	examples := IdentityDictionary new.
	Smalltalk garbageCollect; garbageCollectMost.
	GTExample allInstances do: [ :each | each detachFromSystem ].
	GTExample allSubInstances do: [ :each | each detachFromSystem ].
	GTExampleProxy allInstances do: [ :each | each detachFromSystem ].
	GTExampleProxy allSubInstances do: [ :each | each detachFromSystem ].
	GTExampleResult allInstances do: [ :each | each detachFromSystem ].
	GTExampleResult allSubInstances do: [ :each | each detachFromSystem ].
	Smalltalk garbageCollect; garbageCollectMost.! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 6/21/2015 16:29'!
running
	^ running ifNil: [ false ]! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 9/5/2015 13:42'!
start
	self running ifTrue: [ ^ self ].
	running := true.
	SystemAnnouncer uniqueInstance
		when: MethodAdded do: [ :anAnnouncement | self methodAdded: anAnnouncement ] for: self;
		when: MethodModified do: [ :anAnnouncement | self methodModified: anAnnouncement ] for: self;
		when: MethodRemoved do: [ :anAnnouncement | self methodRemoved: anAnnouncement ] for: self;
		when: ClassRemoved do: [ :anAnnouncement | self classRemoved: anAnnouncement ] for: self;
		when: ClassRenamed do: [ :anAnnouncement | self classRenamed: anAnnouncement ] for: self;
		when: CategoryRemoved do: [ :anAnnouncement | self categoryRemoved: anAnnouncement ] for: self.! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 6/21/2015 17:40'!
stop
	running := false.
	SystemAnnouncer uniqueInstance
		unsubscribe: self! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 8/25/2015 21:07'!
withCleanupDo: aBlock
	aBlock value.
	Smalltalk garbageCollect.! !

Object subclass: #GTExamplePainter
	instanceVariableNames: 'example elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-UI'!

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:42'!
borderColorForExample: anExample
	^ [ self colorForResult: anExample result ]
		on: Error
		do: [ self colorForExample: anExample ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:09'!
buildEdges: aBlock inView: aView
	| edges container fromElement toElements elementsWithModels |
	elements isEmpty ifTrue: [ ^ #() ].
	edges := OrderedCollection new.
	elementsWithModels := elements select: [ :el | el model notNil ].
	
	elementsWithModels do: [ :element |
		container := element view.
		fromElement := container elementFromModel: (#yourself rtValue: element model).
		
		"We get the list of elements that corresponds to (toBlock roValues: element model)"
		toElements := OrderedCollection new.
		([ :node | self dependenciesOrArgumentsForExample: node ] rtValue: element model) do: [ :model | 
			| v |
			v := container elementFromModel: model.
			v notNil ifTrue: [ toElements add: v ] ].
		
		
		(fromElement notNil and: [ toElements notEmpty ])
			ifTrue: [  
				toElements do: [ :toElement |
					| edge line |
					edge := RTEdge from: fromElement to: toElement. 
					line := RTArrowedLine new 
						color: Color black; 
						attachPoint: RTVerticalAttachPoint instance;
						yourself.
					aBlock value: edge value: fromElement value: toElement value: line.
					edge + line.
					edges add: edge.
					container add: edge ] ]  ].
	aView addAll: edges.! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:29'!
buildElements: aRootExample inView: aView
	| traverser |
	" init "
	elements := RTGroup new.
	
	" root element "
	elements add: (self elementForExample: aRootExample with: [ :shape | shape size: 48 ]).
	
	" top-down "
	(traverser := aRootExample traverser)
		onRecursionError: [ :aProcessor :anExample | self onRecursionError: anExample ];
		onArgumentError: [ :aProcessor :anExample :someArguments | self onArgumentError: anExample ];
		onDependencyError: [ :aProcessor :anExample :anException | self onDependencyError: anExample ];
		action: [ :anExample | self onAction: anExample ];
		value.
	
	" bottom up "
	traverser reversed value.
	
	" add to view "
	aView addAll: elements @ (RTPopup text: [ :node | node gtDisplayString ]) @ RTDraggable.! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 15:18'!
buildLayoutinView: aView
	" layout -> graph instead of tree "
	RTTreeLayout new on: elements! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:58'!
colorForExample: anExample
	^ anExample exists 
		ifTrue: [ anExample isValid 
			ifTrue: [ self defaultColorForExample: anExample ] 
			ifFalse: [ Color red ] ] 
		ifFalse: [ (Color r: 1 g: 0 b: 0 alpha: 0.05) ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:58'!
colorForResult: aResult
	aResult isSuccess ifTrue: [ ^ Color green ].
	aResult isFailure ifTrue: [ ^ Color yellow ].
	aResult isError ifTrue: [ ^ Color red ].
	^ self defaultColorForExample: nil! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:57'!
defaultColorForExample: anExample
	^ Color black! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:52'!
dependenciesOrArgumentsForExample: anExample
	^ [ anExample arguments collect: [ :each | 
		[ each example ] 
			on: Error 
			do: [ :exception | each ] ] ] on: Error do: [ #() ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:28'!
elementByExample: anExample
	^ elements 
		detect: [ :element | element model == anExample ] 
		ifNone: [ nil ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:04'!
elementByExample: anExample do: aBlock1 ifNone: aBlock2
	(self elementByExample: anExample)
		ifNotNil: aBlock1
		ifNil: aBlock2! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:38'!
elementForExample: anExample
	^ self elementForExample: anExample with: [ :shape | ]! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:57'!
elementForExample: anExample with: aBlock
	| shape |
	shape := RTBox new 
		size: 24;
		color: (self defaultColorForExample: anExample);
		borderColor: (self borderColorForExample: anExample);
		borderWidth: 2;
		yourself.
	aBlock value: shape.
	^ shape elementOn: anExample! !

!GTExamplePainter methodsFor: 'accessing' stamp: 'StefanReichhart 8/31/2015 22:26'!
example
	^ example! !

!GTExamplePainter methodsFor: 'accessing' stamp: 'StefanReichhart 8/31/2015 22:26'!
example: anObject
	example := anObject! !

!GTExamplePainter methodsFor: 'public' stamp: 'StefanReichhart 8/31/2015 22:56'!
gtInspectorRoassalIn: composite
	self hasRoassal2 ifFalse: [ ^ self ].
	^ composite roassal2
		title: 'Graph';
		painting: [ :view :node | self viewGraph: node on: view ];
		yourself! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:57'!
hasRoassal2
	^ (Smalltalk classNamed: #GLMRoassal2Presentation) notNil! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 21:20'!
onAction: anExample
	self elementByExample: anExample
		do: [ :element | ]
		ifNone: [ elements add: (self elementForExample: anExample) ] ! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:43'!
onArgumentError: anExample
	self elementByExample: anExample
		do: [ :element | 
			element color: Color red.
			(self dependenciesOrArgumentsForExample: anExample) do: [ :argument |
				self elementByExample: argument
					do: [ :subElement | ]
					ifNone: [ elements add: (self elementForExample: argument with: [ :shape | shape 
							color: (self colorForExample: argument); 
							borderColor: (self borderColorForExample: argument) ]) ] ] ]
		ifNone: [ ] ! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 14:38'!
onDependencyError: anExample
	self elementByExample: anExample
		do: [ :element | 
			anExample hasValidArguments 
				ifFalse: [ element color: Color red ] ]
		ifNone: [ 
			elements add: (self elementForExample: anExample) ].
		
	anExample arguments do: [ :argument |
		elements add: (self elementForExample: argument with: [ :shape | shape 
			color: (self colorForExample: argument); 
			borderColor: (self borderColorForExample: argument) ]) ] ! !

!GTExamplePainter methodsFor: 'private' stamp: 'StefanReichhart 9/2/2015 21:19'!
onRecursionError: anExample
	self elementByExample: anExample
		do: [ :element | element color: Color yellow ]
		ifNone: [  ] ! !

!GTExamplePainter methodsFor: 'private-painting' stamp: 'StefanReichhart 9/4/2015 15:23'!
viewGraph: aRootExample on: aView
	self buildElements: aRootExample inView: aView.
	self buildEdges: [ :edge :from :to :line | 
		from model hasValidArguments ifFalse: [ line color: Color red ] ] inView: aView.
	self buildLayoutinView: aView.
	
	^ aView! !

Object subclass: #GTExampleProcessor
	instanceVariableNames: 'example processing onProcess onRecursionError onDependencyError onArgumentError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Example-Tools'!

GTExampleProcessor subclass: #GTExampleEvaluator
	instanceVariableNames: 'processed result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Example-Tools'!

GTExampleEvaluator subclass: #GTExampleDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Example-Tools'!

!GTExampleDebugger methodsFor: 'private' stamp: 'StefanReichhart 7/13/2015 12:14'!
do: aBlock on: anException do: anotherBlock
	aBlock value! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'StefanReichhart 7/13/2015 12:14'!
do: aBlock on: anException do: anotherBlock
	aBlock
		on: anException
		do: anotherBlock! !

!GTExampleEvaluator methodsFor: 'initializing' stamp: 'StefanReichhart 9/6/2015 17:46'!
initialize
	super initialize.
	
	processed := OrderedCollection new.
	result := GTExampleResult new! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 17:01'!
process: anExample withArguments: aBlock
	| value arguments signaledException |
	value := nil.
	arguments := nil.
	signaledException := nil.
	anExample hasValidArguments 
		ifFalse: [ ^ self onArgumentError value: self value: anExample value: arguments ].
	[ arguments := aBlock value ]
		on: Error
		do: [ :exception | ^ self onDependencyError value: self value: anExample value: exception ].
	self do: [ value := anExample method valueWithReceiver: anExample provider arguments: arguments ]
		on: (anExample exceptions copyWith: Error)
		do: [ :exception | signaledException := exception ].
	processed add: { anExample. value. signaledException }.
	result returnValue: value.
	anExample exceptions signaledBy: signaledException.
	result expectedError: signaledException.
	^ value! !

!GTExampleEvaluator methodsFor: 'public' stamp: 'StefanReichhart 8/31/2015 21:54'!
result
	result example: self example.
	self do: [ self value ] 
		on: Error
		do: [ :exception | result returnValue: nil; unexpectedError: exception ].
	^ result! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 8/26/2015 21:24'!
basicProcess: anExample 
	^ self 
		process: anExample 
		withArguments: [ anExample arguments collect: [ :each | self process: each example ] ] ! !

!GTExampleProcessor methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 17:44'!
canProcess
	[ self value ]
		on: GTExampleError
		do: [ ^ false ].
	^ true! !

!GTExampleProcessor methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 8/31/2015 22:06'!
defaultOnArgumentError
	^ [ :aProcessor :anExample :someArguments | 
		aProcessor handleArgumentErrorFor: anExample withArguments: someArguments.
		nil ]! !

!GTExampleProcessor methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 8/31/2015 22:06'!
defaultOnDependencyError
	^ [ :aProcessor :anExample :anException | 
		aProcessor handleDependencyErrorFor: anExample withException: anException.
		nil ]! !

!GTExampleProcessor methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 9/2/2015 20:58'!
defaultOnProcess
	^ [ :aProcessor :anExample | 
		aProcessor basicProcess: anExample ]! !

!GTExampleProcessor methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 8/31/2015 22:06'!
defaultOnRecursionError
	^ [ :aProcessor :anExample | 
		aProcessor handleRecursionErrorFor: anExample.
		nil ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:48'!
example
	^ example! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:48'!
example: anObject
	example := anObject! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:44'!
handleArgumentErrorFor: anExample withArguments: arguments
	^ (GTExampleArgumentError new
		example: anExample;
		expected: anExample method argumentNames;
		defined: anExample arguments;
		evaluated: arguments;
		yourself) signal! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:43'!
handleDependencyErrorFor: anExample withException: anException
	^ (GTExampleDependencyError new
		example: anExample;
		exception: anException;
		yourself) signal! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 17:43'!
handleRecursionErrorFor: anExample
	^ (GTExampleRecursionDetected new 
		example: self example;
		resolved: processing;
		next: anExample;
		yourself) signal! !

!GTExampleProcessor methodsFor: 'initializing' stamp: 'StefanReichhart 7/26/2015 15:14'!
initialize
	super initialize.
	
	processing := IdentitySet new.
	! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 8/29/2015 19:17'!
onArgumentError
	^ onArgumentError ifNil: [ onArgumentError := self defaultOnArgumentError ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 8/29/2015 19:17'!
onArgumentError: anObject
	onArgumentError := anObject! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/27/2015 14:29'!
onDependencyError
	^ onDependencyError ifNil: [ onDependencyError := self defaultOnDependencyError ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/27/2015 14:29'!
onDependencyError: anObject
	onDependencyError := anObject! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 15:21'!
onProcess
	^ onProcess ifNil: [ onProcess := self defaultOnProcess ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 15:21'!
onProcess: anObject
	onProcess := anObject! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 16:02'!
onRecursionError
	^ onRecursionError ifNil: [ onRecursionError := self defaultOnRecursionError ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 15:57'!
onRecursionError: anObject
	onRecursionError := anObject! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 8/23/2015 15:23'!
process: anExample
	^ self process: anExample withoutLoopsDo: [ 
		self onProcess value: self value: anExample ]! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 16:55'!
process: anExample withArguments: aBlock
	self subclassResponsibility! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 8/2/2015 12:52'!
process: anExample withoutLoopsDo: aBlock
	| value |
	" check whether we already scheduled the given example for processing -> prevent recursion "
	value := nil.
	processing do: [ :processingExample |
		(processingExample equalsExample: anExample) ifTrue: [
			^ self onRecursionError value: self value: anExample ] ].	
	processing add: anExample. " prepare processing this example "
	value := aBlock value. " process this example "
	processing remove: anExample. " done processing "
	^ value! !

!GTExampleProcessor methodsFor: 'public' stamp: 'StefanReichhart 8/29/2015 18:51'!
value 
	^ self process: self example! !

GTExampleProcessor subclass: #GTExampleTraverser
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Example-Tools'!

!GTExampleTraverser methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 15:04'!
action
	^ action! !

!GTExampleTraverser methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 15:04'!
action: anObject
	action := anObject! !

!GTExampleTraverser methodsFor: 'private' stamp: 'StefanReichhart 8/31/2015 22:11'!
process: anExample withArguments: aBlock
	| arguments |
	arguments := nil.
	anExample hasValidArguments 
		ifFalse: [ ^ self onArgumentError value: self value: anExample value: arguments ].
	[ arguments := aBlock value ]
		on: Error
		do: [ :exception | ^ self onDependencyError value: self value: anExample value: exception ].
	self action ifNotNil: [ self example == anExample ifFalse: [ self action value: anExample ] ]! !

!GTExampleTraverser methodsFor: 'accessing' stamp: 'StefanReichhart 8/29/2015 18:53'!
reversed
	self onProcess: [ :processor :anExample | 
		self action ifNotNil: [ self example == anExample ifFalse: [ self action value: anExample ] ].
		anExample dependents do: [ :each | processor process: each ] ]! !

Object subclass: #GTExampleProxy
	instanceVariableNames: 'owner provider selector example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Utils'!

!GTExampleProxy methodsFor: 'testing' stamp: 'StefanReichhart 8/25/2015 22:01'!
= anExampleProxy
	^ self class = anExampleProxy class 
		and: [ self owner = anExampleProxy owner 
			and: [ self selector = anExampleProxy selector ] ]! !

!GTExampleProxy methodsFor: 'private' stamp: 'StefanReichhart 8/25/2015 20:56'!
detachFromSystem
	example ifNotNil: [ example parents remove: self ifAbsent: [ ] ].
	example := nil! !

!GTExampleProxy methodsFor: 'testing' stamp: 'StefanReichhart 8/2/2015 12:08'!
equalsExample: anExampleOrExampleProxy
	^ self withExampleDo: [ anExampleOrExampleProxy equalsExample: self example ] ifAbsent: [ false ] ! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 17:43'!
example
	example ifNil: [ self resolve ].
	^ example! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 6/17/2015 13:10'!
example: anObject
	example := anObject! !

!GTExampleProxy methodsFor: 'testing' stamp: 'StefanReichhart 8/25/2015 22:01'!
exists
	^ self owner finder proxyExists: self! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 7/18/2015 19:37'!
gtDebuggerSourceIn: composite
	<gtDebuggerPresentationOrder: 1>
	self withExampleDo: [ self example gtDebuggerSourceIn: composite ]! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 9/2/2015 21:41'!
gtDisplayOn: aStream
	self withExampleDo: [ self example gtDisplayOn: aStream ] ifAbsent: [ 
		aStream nextPutAll: 'anExample ('.
		aStream nextPutAll: self provider class name; nextPutAll: '>>#'; nextPutAll: self selector.
		aStream nextPutAll: ')' ]! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 14:00'!
gtDisplaySummaryOn: aStream
	self withExampleDo: [ self example gtDisplaySummaryOn: aStream ] ! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 14:14'!
gtInspectorDependenciesIn: composite
	<gtInspectorPresentationOrder: 1>
	^ self withExampleDo: [ self example gtInspectorDependenciesIn: composite ]! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 14:14'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 0>
	^ self withExampleDo: [ self example gtInspectorSourceIn: composite ]! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 8/24/2015 21:31'!
gtSpotterDependenciesFor: aStep
	<spotterOrder: 1>
	aStep listProcessor
		title: 'Example Dependencies';
		allCandidates: [ self example arguments ];
		itemName: [ :each | each gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 8/25/2015 22:10'!
gtSpotterDependentsFor: aStep
	<spotterOrder: 2>
	aStep listProcessor
		title: 'Example Dependents';
		allCandidates: [ self example dependents ];
		itemName: [ :each | each gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleProxy methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 13:58'!
gtSpotterPreviewIn: aComposite
	<spotterPreview: 1>
	self withExampleDo: [ self example gtSpotterPreviewIn: aComposite ]! !

!GTExampleProxy methodsFor: 'public' stamp: 'StefanReichhart 8/25/2015 22:01'!
hash
	^ (self class hash 
		bitXor: self owner hash) 
			bitXor: self selector hash! !

!GTExampleProxy methodsFor: 'testing' stamp: 'StefanReichhart 8/25/2015 22:01'!
matchesMethod: aCompiledMethod
	^ self owner finder proxy: self matchesMethod: aCompiledMethod! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 8/25/2015 22:00'!
owner
	^ owner! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 8/25/2015 22:00'!
owner: anObject
	owner := anObject! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 7/29/2015 11:43'!
provider
	^ provider! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 7/29/2015 11:43'!
provider: anObject
	provider := anObject! !

!GTExampleProxy methodsFor: 'private' stamp: 'StefanReichhart 8/26/2015 21:03'!
resolve
	example := (self owner finder copy
		subjects: nil; " do not inherit subjects from the owner -> #initializeFromFinder:withPragma: "
		yourself) proxy: self.
	example ifNotNil: [ example parents add: self ]! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 6/17/2015 13:08'!
selector
	^ selector! !

!GTExampleProxy methodsFor: 'accessing' stamp: 'StefanReichhart 9/4/2015 13:40'!
selector: anObject
	selector := anObject! !

!GTExampleProxy methodsFor: 'private' stamp: 'StefanReichhart 7/18/2015 19:37'!
withExampleDo: aBlock
	^ self withExampleDo: aBlock ifAbsent: [ " ignore " ]! !

!GTExampleProxy methodsFor: 'private' stamp: 'StefanReichhart 7/18/2015 19:37'!
withExampleDo: aBlock ifAbsent: anotherBlock
	^ [ aBlock value ]
		on: Error
		do: anotherBlock! !

Object subclass: #GTExampleResult
	instanceVariableNames: 'example returnValue expectedError unexpectedError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector-Examples-Utils'!

!GTExampleResult methodsFor: 'actions' stamp: 'StefanReichhart 8/25/2015 21:36'!
debug
	self isSuccess ifTrue: [ ^ self ].
	^ self example debug! !

!GTExampleResult methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 13:46'!
detachFromSystem
	example ifNotNil: [ example result: nil ].
	example := returnValue := expectedError := unexpectedError := nil.! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 6/28/2015 16:53'!
example
	^ example! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 6/28/2015 16:53'!
example: anObject
	example := anObject! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:46'!
expectedError
	^ expectedError! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:46'!
expectedError: anObject
	expectedError := anObject! !

!GTExampleResult methodsFor: 'ui' stamp: 'StefanReichhart 8/2/2015 14:19'!
gtDisplayOn: aStream
	self printOn: aStream.
	aStream nextPutAll: ' ('.
	self gtDisplaySummaryOn: aStream.
	aStream nextPutAll: ')'
! !

!GTExampleResult methodsFor: 'ui' stamp: 'StefanReichhart 9/4/2015 15:49'!
gtDisplaySummaryOn: aStream
	self unexpectedError 
		ifNotNil: [ self unexpectedError printOn: aStream ]
		ifNil: [ self returnValue printOn: aStream ].
! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:47'!
isError
	^ self isSuccess not
		and: [ self unexpectedError isExampleError ]! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:53'!
isExpectedError
	^ self expectedError notNil! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:47'!
isFailure
	^ self isSuccess not
		and: [ self unexpectedError isExampleError not ]! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:47'!
isSuccess
	^ self unexpectedError isNil! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:54'!
isUnexpectedError
	^ self unexpectedError notNil! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 11:59'!
returnValue
	^ returnValue! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 11:59'!
returnValue: anObject
	returnValue := anObject! !

!GTExampleResult methodsFor: 'actions' stamp: 'StefanReichhart 8/25/2015 21:36'!
run
	^ self example run! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:46'!
unexpectedError
	^ unexpectedError! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:47'!
unexpectedError: anObject
	unexpectedError := anObject! !

Object subclass: #GTInspectorPresentationFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspectorPresentationFilter commentStamp: 'AndreiChis 1/27/2015 23:31' prior: 0!
A GTInspectorPresentationFilter is the root class for filters that can limit the number if visible presentations for an object.

Subclasses need to implement  #shouldDisplayPresentationCreateBy: to indicate whether or not a give presentation should be displayed.
!

GTInspectorPresentationFilter subclass: #GTInspectorMethodListFilter
	instanceVariableNames: 'allMethodSignatures selectedMethodSignatures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspectorMethodListFilter commentStamp: 'AndreiChis 1/27/2015 23:30' prior: 0!
GTInspectorMethodListFilter implements a filtering strategy for presentations based on method signatures (method selector and class).

The filter returns true for a method if the signature of that method is selected in the filter. To be taken into account during filtering a signature must be first added to the filter and the selected. Only signatures that have been first added can be selected. !

!GTInspectorMethodListFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleASTBrowser
	"An inspector showing a browser for navigating through AST nodes."
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorMethodListFilter new
		addAndSelectSignatureFor: CompiledMethod>>#gtInspectorASTIn:;
		addAndSelectSignatureFor: RBProgramNode>>#gtInspectorSourceCodeIn:).
	inspector openOn: Morph>>#initialize.! !

!GTInspectorMethodListFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleCodeBrowser
	"An inspector showing only the Meta presentation for all objects"
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorMethodListFilter new
		addAndSelectSignatureFor: Object>>#gtInspectorMetaIn:).
	inspector openOn: Morph new.! !

!GTInspectorMethodListFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleFileBrowser
	"An inspector for browsing directories and files."
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorMethodListFilter new
		addAndSelectSignatureFor: FileReference>>#gtInspectorStScriptIn:;
		addAndSelectSignatureFor: FileReference>>#gtInspectorPngIn:;
		addAndSelectSignatureFor: FileReference>>#gtInspectorJpegIn:;
		addAndSelectSignatureFor: FileReference>>#gtInspectorItemsIn:;
		addAndSelectSignatureFor: FileReference>>#gtInspectorGifIn:;
		addAndSelectSignatureFor: FileReference>>#gtInspectorContentsIn:;
		addAndSelectSignatureFor: FileReference>>#gtInspectorFuelIn:).
	inspector openOn: FileSystem workingDirectory.! !

!GTInspectorMethodListFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleFullInspector
	"An inspector showing all presentations for all objects"
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorMethodListFilter new
		addAndSelectAllSignatures).
	inspector openOn: Morph new.! !

!GTInspectorMethodListFilter class methodsFor: 'examples' stamp: 'AndreiChis 3/6/2015 10:33'!
exampleHelpBrowser
	"An inspector for browsing Help pages.
	
	self exampleHelpBrowser
	"
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorMethodListFilter new
		addAndSelectSignatureFor: HelpTopic>>#gtInspectorContentsIn:;
		addAndSelectSignatureFor: HelpTopic>>#gtInspectorSubtopicsIn:).
	inspector openOn: SystemHelp asHelpTopic.! !

!GTInspectorMethodListFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleRawInspector
	"An inspector showing only the Raw presentation for all objects"
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorMethodListFilter new
		addAndSelectSignatureFor: Object>>#gtInspectorRawIn:).
	inspector openOn: Morph new.! !

!GTInspectorMethodListFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:28'!
addAllSignatures
	
	self allPresentationMethods do: [ :aMethod | self addSignatureFor: aMethod ] ! !

!GTInspectorMethodListFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:33'!
addAndSelectAllSignatures
	
	self allPresentationMethods do: [ :aMethod | self addAndSelectSignatureFor: aMethod ] ! !

!GTInspectorMethodListFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:46'!
addAndSelectSignatureFor: aMethod
	|signature|
	
	signature := self signatureFor: aMethod.
	(allMethodSignatures includes: signature) ifFalse: [ allMethodSignatures add: signature ].
	(selectedMethodSignatures includes: signature) ifFalse: [ selectedMethodSignatures add: signature ].
	! !

!GTInspectorMethodListFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:24'!
addSignatureFor: aMethod
	|signature|
	
	signature := self signatureFor: aMethod.
	(allMethodSignatures includes: signature) ifFalse: [ allMethodSignatures add: signature ].! !

!GTInspectorMethodListFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 11:32'!
allPresentationMethods

	^ (PragmaCollector allSystemPragmas select: [ :pragma | 
		pragma key == self inspectorPragmaKey ]) collect: [ :aPragma | aPragma method ]! !

!GTInspectorMethodListFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 12:06'!
changeFilterRequestFor: aGTInspector

	self
		openListChooseLabeled: 'All available presentations' 
		forInspector: aGTInspector
		with: allMethodSignatures 
		select: selectedMethodSignatures 
		format: [ :aSignature | self printSignature: aSignature ]
		actionSelector: #replaceSelectedSignaturesWith:in:! !

!GTInspectorMethodListFilter methodsFor: 'initialization' stamp: 'AndreiChis 12/13/2014 11:43'!
initialize
	super initialize.
	allMethodSignatures := OrderedCollection new.
	selectedMethodSignatures := OrderedCollection new.! !

!GTInspectorMethodListFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 11:31'!
inspectorPragmaKey

	^ #gtInspectorPresentationOrder:! !

!GTInspectorMethodListFilter methodsFor: 'printing' stamp: 'AndreiChis 12/13/2014 12:06'!
printSignature: aSignature

	^ aSignature first name, '>>', aSignature second asString! !

!GTInspectorMethodListFilter methodsFor: 'callbacks' stamp: 'AndreiChis 12/13/2014 11:46'!
replaceSelectedSignaturesWith: aList in: aGTInspector

	selectedMethodSignatures := aList.
	aGTInspector update! !

!GTInspectorMethodListFilter methodsFor: 'testing' stamp: 'AndreiChis 12/13/2014 12:03'!
shouldDisplayPresentationCreateBy: aMethod

	^ selectedMethodSignatures anySatisfy: [ :aSignature | 
		aSignature first = aMethod methodClass and: [ aSignature second = aMethod selector ] ]! !

!GTInspectorMethodListFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 12:03'!
signatureFor: aMethod

	^ {aMethod methodClass . aMethod selector}! !

!GTInspectorPresentationFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/9/2014 22:38'!
changeFilterRequestFor: aGTInspector

	self subclassResponsibility! !

!GTInspectorPresentationFilter methodsFor: 'private' stamp: 'AndreiChis 12/13/2014 12:04'!
openListChooseLabeled: sString forInspector: aGTInspector with: allElements select: selectedElements format: aBlockOrSelector actionSelector: aSymbol
	|treeModel|
	
	treeModel := MorphTreeModel new.
	treeModel
		 beCheckList;
		 rootItems: allElements;
		 wrapBlockOrSelector: aBlockOrSelector;
		 autoMultiSelection: true.
	 (treeModel openDialogWindowIn: World title: sString selectedtems: selectedElements) ifNotNil: [ :selection | 
		self perform: aSymbol with: selection with: aGTInspector ]! !

!GTInspectorPresentationFilter methodsFor: 'testing' stamp: 'AndreiChis 12/9/2014 21:27'!
shouldDisplayPresentationCreateBy: aMethod

	self subclassResponsibility! !

GTInspectorPresentationFilter subclass: #GTInspectorTagFilter
	instanceVariableNames: 'allTags selectedTags defaultTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspectorTagFilter commentStamp: 'AndreiChis 1/27/2015 23:31' prior: 0!
GTInspectorTagFilter implements a filtering strategy for presentations based on tags.

A tag is defined as the parameter of the prama <gtInspectorTag:>. A method can have one or more tags.
The filter returns true for a method if that method contains at least a tag selected in the filter. To be taken into account during filtering a tag must be first added to the filter and the selected. Only tags that have been first added can be selected.  

If a method does not define any tags the filter threats that method as having a single tag stored in the #defaultTag instance variable. The default defaultTag is #custom. The #basic tag  groups the Raw and Meta presentations. Inspect 'GTInspectorTagFilter new allPragmasWithTag' to view all pragmas creating the tags.!

!GTInspectorTagFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleBasicInspector
	"An inspector showing only the basic presentations Raw and Meta for all object."
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorTagFilter new
		addAndSelectTag: #basic).
	inspector openOn: Morph new.! !

!GTInspectorTagFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleCustomInspector
	"An inspector showing only the custom presentations for all object (excluding Raw and Meta)."
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorTagFilter new
		defaultTag: #custom;
		addAndSelectTag: #custom).
	inspector openOn: Morph new.! !

!GTInspectorTagFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleExampleBrowser
	"A browser for viewing examples"
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorTagFilter new
		addAndSelectTag: #examples).
	inspector openOn: Dictionary.! !

!GTInspectorTagFilter class methodsFor: 'examples' stamp: 'AndreiChis 1/27/2015 23:30'!
exampleFullInspector
	"An inspector showing all the available presentations for all objects."
	|inspector|
	
	inspector := GTInspector new.
	inspector presentationFilter: (GTInspectorTagFilter new
		defaultTag: #custom;
		addAndSelectTag: #custom;
		addAndSelectAllTags).
	inspector openOn: Morph new.! !

!GTInspectorTagFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:15'!
addAllTags
	
	self allTags do: [ :aTag | self addTag: allTags ] ! !

!GTInspectorTagFilter methodsFor: 'adding' stamp: 'AndreiChis 1/14/2015 15:21'!
addAndSelectAllTags
	
	self allTags do: [ :aTag | self addAndSelectTag: aTag ] ! !

!GTInspectorTagFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:16'!
addAndSelectTag: aSymbol

	self addTag: aSymbol.
	(selectedTags includes: aSymbol) ifFalse:  [selectedTags add: aSymbol]! !

!GTInspectorTagFilter methodsFor: 'adding' stamp: 'AndreiChis 12/13/2014 11:16'!
addTag: aSymbol

	(allTags includes: aSymbol) ifFalse:  [allTags add: aSymbol].! !

!GTInspectorTagFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 11:13'!
allPragmasWithTag

	^ PragmaCollector allSystemPragmas select: [ :pragma | pragma key == self tagPragmaKey ]! !

!GTInspectorTagFilter methodsFor: 'accessing' stamp: 'AndreiChis 1/14/2015 15:18'!
allTags

	^ (self allPragmasWithTag collect: [ :pragma | 
		pragma argumentAt: 1 ]) asSet sorted: [ :a :b | a < b ]! !

!GTInspectorTagFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 12:05'!
changeFilterRequestFor: aGTInspector

	self
		openListChooseLabeled: 'All available tags' 
		forInspector: aGTInspector
		with: allTags 
		select: selectedTags 
		format: #printString
		actionSelector: #replaceSelectedTagsWith:in:
! !

!GTInspectorTagFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 00:38'!
defaultTag: aSymbol

	defaultTag := aSymbol! !

!GTInspectorTagFilter methodsFor: 'initialization' stamp: 'AndreiChis 12/13/2014 10:59'!
initialize
	super initialize.
	
	allTags := OrderedCollection new.
	selectedTags := OrderedCollection new.
	defaultTag := #custom! !

!GTInspectorTagFilter methodsFor: 'callbacks' stamp: 'AndreiChis 12/13/2014 11:40'!
replaceSelectedTagsWith: aListOfSymbols in: aGTInspector

	selectedTags := aListOfSymbols.
	aGTInspector update.! !

!GTInspectorTagFilter methodsFor: 'testing' stamp: 'AndreiChis 12/13/2014 11:03'!
shouldDisplayPresentationCreateBy: aMethod

	^ (self tagsFrom: aMethod) includesAny: selectedTags! !

!GTInspectorTagFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 11:11'!
tagPragmaKey

	^ #gtInspectorTag:! !

!GTInspectorTagFilter methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2014 11:11'!
tagsFrom: aMethod

	^ (aMethod pragmas select: [ :each | each key == self tagPragmaKey ])
		ifEmpty: [ defaultTag ifNil: [ {} ] ifNotNil: [ {defaultTag} ] ]
		ifNotEmpty: [ :currentPragmas | currentPragmas collect: [ :each | each argumentAt: 1 ] ]! !

Object subclass: #GTObjectPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectPrinter commentStamp: 'TudorGirba 1/18/2014 14:29' prior: 0!
This is a utility class for printing objects to Text or String.!

!GTObjectPrinter methodsFor: 'printing' stamp: 'TudorGirba 12/23/2013 09:17'!
asNonTruncatedTextFrom: anObject
	^ [ Text fromString: (anObject asString replaceAll: String cr with: String space) ] 
			on: Error 
			do: [ Text string: 'error printing' attribute: TextColor red ]! !

!GTObjectPrinter methodsFor: 'printing' stamp: 'TudorGirba 9/6/2014 19:03'!
asTruncatedTextFrom: anObject
	^ [ Text fromString: (anObject gtDisplayString replaceAll: String cr with: String space) ]
		on: Error
		do: [ Text string: 'error printing' attribute: TextColor red ]! !

Object subclass: #GTSnippets
	instanceVariableNames: 'instance snippets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

GTSnippets class
	instanceVariableNames: 'instance'!

!GTSnippets commentStamp: '<historical>' prior: 0!
GTSnippets instance!

GTSnippets class
	instanceVariableNames: 'instance'!

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 14:55'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 2/2/2014 14:05'!
reset
	instance := nil! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 15:00'!
snippetAt: anObject
	^ self instance snippetAt: anObject! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 15:10'!
snippetAt: anObject put: aString
	^ self instance snippetAt: anObject put: aString! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 12/30/2013 23:44'!
snippetAt: anObject
	^ self snippets 
		at: anObject 
		ifAbsent: [ 'self' ]! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 12/30/2013 23:44'!
snippetAt: anObject put: aString
	^ self snippets 
		at: anObject 
		put: aString! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 5/26/2014 12:39'!
snippetAtOrEmpty: anObject
	^ self snippets 
		at: anObject 
		ifAbsent: [ '' ]! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 14:59'!
snippets 
	^ snippets ifNil: [ snippets := IdentityDictionary new ]! !

!Object methodsFor: '*GT-Inspector-Examples-Core-private' stamp: 'StefanReichhart 8/25/2015 20:56'!
detachFromSystem! !

!Object methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 6/21/2015 19:58'!
equalsExample: anExampleOrExampleFutureOrSomethingElse
	^ false! !

!Object methodsFor: '*GT-Inspector' stamp: 'TudorGirba 12/23/2013 09:12'!
gtDisplayOn: stream
	"This offers a means to customize how the object is shown in the inspector"
	^ self printOn: stream! !

!Object methodsFor: '*GT-Inspector' stamp: 'TudorGirba 12/28/2013 21:59'!
gtDisplayString
	"This offers a means to customize how the object is shown in the inspector.
	Do not override this method. Override gtDisplayOn: instead"
		
	| limitedString limit |
	limit := 1000.
	limitedString := String streamContents: [:s | self gtDisplayOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , ' ...'! !

!Object methodsFor: '*GT-Inspector-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:32'!
gtExamples
	^ self class gtExamples! !

!Object methodsFor: '*GT-Inspector-Examples-UI' stamp: 'StefanReichhart 9/6/2015 16:36'!
gtExamplesContained
	^ [ self gtExamples ]
		on: Error
		do: [ #() ]! !

!Object methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/27/2014 21:42'!
gtInspectorActionBrowse
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self browse ];
		icon: GLMUIThemeExtraIcons glamorousBrowse;
		title: 'Browse'! !

!Object methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/27/2014 10:36'!
gtInspectorActions
	"This is a utility method that allows each object to define a set of actions 
	specific for itself. These actions are used when the object appears in the inspector.

	The actions are collected based on the #gtInspectorAction pragma that are defined in
	unary methods corresponding to the body of the actions"
	
	| all |
	all := (Pragma 
				allNamed: #gtInspectorAction
				from: self class 
				to: Object) collect: [:eachPragma |
					self perform: eachPragma selector ].
	^ all asSortedCollection: [:a :b | 
		| first second |
		first := a isCategorized ifTrue: [a category, a title] ifFalse: [a title].
		second := b isCategorized ifTrue: [b category, b title] ifFalse: [b title].
		first < second]! !

!Object methodsFor: '*GT-Inspector' stamp: 'TudorGirba 6/28/2014 22:18'!
gtInspectorInterestingObject
	^ self! !

!Object methodsFor: '*GT-Inspector' stamp: 'AndreiChis 12/13/2014 11:00'!
gtInspectorMetaIn: composite
	"This presentation offers the methods of the class of the current object"
	<gtInspectorPresentationOrder: 1000>
	<gtInspectorTag: #basic>
	^ composite custom: (GTSimpleMethodsBrowser new startOn: self) ! !

!Object methodsFor: '*GT-Inspector' stamp: 'AndreiChis 1/14/2015 14:22'!
gtInspectorPresentationsIn: composite inContext: aGTInspector
	"This is a utility method that collects all presentations for the current object.
	By default, it simply looks for the #gtInspectorPresentationOrder: pragma.
	The inspector can decice whether or not a presentation should be dispayed.
	Subclasses might want to override it for more special behavior."
	| pragmas |
	pragmas := Pragma 
				allNamed: #gtInspectorPresentationOrder: 
				from: self class 
				to: Object
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas := pragmas select: [ :aPragma | 
		aGTInspector shouldDisplayPresentationCreateBy: aPragma method ].
	pragmas do: [ :eachPragma | 
		(eachPragma selector findTokens: $:) size = 1 
			ifTrue: [ self perform: eachPragma selector with: composite ]. 
		(eachPragma selector findTokens: $:) size = 2
			ifTrue: [ self perform: eachPragma selector with: composite with: aGTInspector ] ]! !

!Object methodsFor: '*GT-Inspector' stamp: 'AndreiChis 12/13/2014 11:00'!
gtInspectorRawIn: composite
	"This is the most basic presentation showing the state of the object"
	<gtInspectorPresentationOrder: 10>
	<gtInspectorTag: #basic>
	^ composite custom: GTObjectVariablesBrowser new! !

!Object methodsFor: '*GT-Inspector' stamp: 'TommasoDalSasso 1/30/2015 16:32'!
gtInspectorVariableValuePairs
	"This is a helper method that returns a collection of 
		variable_name -> value
	for the current object.
	Subclasses can override it to specialize what appears in the variables presentation"
	| bindings |
	bindings := OrderedCollection new.
					
	1 to: (self basicSize min: 21) do: [ :index | 
		bindings add: (index "asString""asTwoCharacterString" -> (self basicAt: index)) ].
	
	((self basicSize - 20) max: 22) to: (self basicSize) do: [ :index | "self haltIf: [ index = 99 ]."
		bindings add: (index "asString" -> (self basicAt: index)) ].
	
	bindings
		addAll: ((self class allSlots 
					collect: [ :slot | slot name -> (slot read: self) ]) sort asOrderedCollection).
	^ bindings! !

!Object methodsFor: '*GT-Inspector-Examples-Core' stamp: 'AndreiChis 10/30/2014 14:24'!
isGTExample
	
	^ false! !

GTInspector initialize!
